---
<%-
  require 'date'
  require 'set'
  
  r_versions = []
  default_partition = nil
  default_account = `sacctmgr -n -P list user $USER format=DefaultAccount`
  reservations = Set.new
  accounts = {}
  partitions = {}
  gpus = {}

  # get R versions available
  r_versions=`ls -1 /shared/software/modulefiles/r/`.split(/\n+/).sort

  # get partitions and gres
  sinfo_lines=`sinfo -h -o "%P|%G"`.split(/\n+/)
  for sinfo_line in sinfo_lines do
    partition, all_gres = sinfo_line.split('|')

    # check if this is default partition
    if partition.end_with?("*")
      partition = partition[0, partition.length()-1]
      default_partition = partition
    end

    # adding partition to partitions objects
    if !partitions.key?(partition)
        partitions[partition] = {
            'accounts' => Set.new,
            'reservations' => Set.new
        }
    end

    # collecting gpus from current partition
    gpus_list = Set.new
    for gres_item in all_gres.split(',')
      if gres_item != '(null)'
        gres_type, gres_name, gres_qty = gres_item.split(':')
        if gres_type == 'gpu'
          if !gpus.key?(gres_name)
              gpus[gres_name] = {
                  'partitions' => Set.new
              }
          end
          gpus[gres_name]['partitions'] << partition
        end
      end
    end
  end

  # get accounts and partitions associations
  sacctmgr_lines = `sacctmgr list -n -P associations user=$USER format=account%250,partition%250`.split(/\n+/)
  for sacctmgr_line in sacctmgr_lines
    account, partition = sacctmgr_line.split('|')
    if !accounts.key?(account)
      accounts[account] = {
          'reservations' => Set.new
      }
    end

    if partition == ''
        # this account has access to all partitions
        for partition in partitions.keys
          partitions[partition]['accounts'] << account
        end
    else
      if partitions.key?(partition)
        partitions[partition]['accounts'] << account
      end
    end
  end

  # get reservations
  scontrol_result = `scontrol show reservation -o`
  if !scontrol_result.include?("No reservations in the system")
    for reservation_line in scontrol_result.split(/\n+/)
      is_usable = false
      reservation = {}
      for reservation_part in reservation_line.split(' ')
        parts = reservation_part.split('=')
        if parts.length == 2 and parts[1] != '(null)'
            reservation[parts[0]] = parts[1]
        else
            reservation[parts[0]] = nil
        end
      end

      if reservation['Accounts'] == nil
         # this reservation is available for all accounts
         reservation['Accounts'] = accounts.keys
         is_usable = true
      else
        reservation['Accounts'] = reservation['Accounts'].split(',')
        reservation_accounts = reservation['Accounts'].split(',')
        is_usable = reservation['Accounts'].intersection(accounts.keys).length > 0
      end

      if reservation['PartitionName'] != nil
        # we need to check if we have at least one account which has access to this partition
        for account in reservation['Accounts']
          if !partitions[reservation['PartitionName']]['accounts'].include?(account)
            reservation['Accounts'].delete(account)
          end
        end
        if reservation['Accounts'].length == 0
          is_usable = false
        end
      end

      if is_usable
        reservations << reservation['ReservationName']
        for account in reservation['Accounts']
          accounts[account]['reservations'] << reservation['ReservationName']
        end
        if reservation['PartitionName'] != nil
            partitions[reservation['PartitionName']]['reservations'] << reservation['ReservationName']
        else
            for partition in partitions.keys
                partitions[partition]['reservations'] << reservation['ReservationName']
            end
        end
      end
    end
  end
%>


cluster: "*"

attributes:
  rstudio_version: "2023.03.1-446"
  force_newgrp: "false"

  bc_num_slots: 1
  r_version:
    widget: "select"
    options:
      <% r_versions.each do |version| %>
      - "<%= version %>"
      <% end %>
    value: "<%= r_versions[- 1] %>"
    label: "R version"
    display: true
  bc_num_hours:
    max: 12
    value: 1
  slurm_reservation:
    widget: select
    required: false
    label: Reservation
    options:
      - ['No reservation', '']
      <% reservations.each do |reservation| %>
      - ['<%= reservation %>', '<%= reservation %>']
      <% end %>
    value: ''
    display: true
  slurm_account:
    widget: select
    label: Account
    required: true
    options:
      <% accounts.keys.each do |account| %>
      - ['<%= account %>',
         '<%= account %>',
         data-reservations: <%= accounts[account]['reservations'].to_a.join(" ") %>,
        ]
      <% end %>
    value: <%= default_account %>
    display: true
  slurm_partition:
    widget: select
    cacheable: false
    label: Partition
    required: true
    options:
      <% partitions.keys.each do |partition| %>
      - ['<%= partition %>',
         '<%= partition %>',
          data-accounts: "<%= partitions[partition]['accounts'].to_a.join(" ") %>",
          data-reservations: "<%= partitions[partition]['reservations'].to_a.join(" ") %>",
        ]
      <% end %>
    value: <%= default_partition %>
    display: true
  slurm_gpu_count:
    widget: number_field
    cacheable: false
    label: Number of GPUs
    required: false
    value: 0
    display: true
  slurm_gpu:
    widget: select
    cacheable: false
    label: GPUs
    required: fale
    options:
      - ['No GPU', '']
      <% gpus.keys.each do |gpu| %>
      - ['<%= gpu %>',
         '<%= gpu %>',
          data-partitions: "<%= gpus[gpu]['partitions'].to_a.join(" ") %>",
        ]
      <% end %>
    display: true
  slurm_cpu:
    widget: number_field
    min: 2
    label: Number of CPUs
    required: true
    value: 1
    display: true
    help: You should reserve at least 2 CPUs to have enough resources for RStudio server and R.
  slurm_mem:
    widget: text_field
    value: 1G
    required: true
    label: Amount of memory
    display: true
    help: |
      RStudio requires an amount of memory roughly equal to the amount of data you would like to load in your session.
      Unit can be specified using the suffix M, G or T (default is megabytes).


form:
  - bc_num_slots
  - rstudio_version
  - r_version
  - slurm_reservation
  - slurm_account
  - slurm_partition
  - slurm_cpu
  - slurm_mem
  - slurm_gpu_count
  - slurm_gpu
  - bc_num_hours
  - force_newgrp
